//
//  LeafBlock.swift
//  MarkRight
//
//  Created by Octree on 2018/4/11.
//  Copyright © 2018年 Octree. All rights reserved.
//

import Foundation


/*********************************************
 **********   Leaf Block Parser   ***********
 ********************************************/

/************************************ MARKDOWN TABLE ******************************************/

private let tableSep = character { $0 == "|" }
private let hyphen = character { $0 == "-" }


// no sense, just report bug
enum InlineNode {
    
    case any
}

// no sense, just report bug
enum BlockNode {
    case any
}

private let colon = character { $0 == ":" }

private let tableData = space.many *> (not(tableSep <|> lineEnding) >>- {
    substring in
    return Parser<Substring, [InlineNode]> {
//        do nothing, just report bug
        return .done($0, [])
    }
    }) <* space.many

private typealias TableDataNodeGen = (TableDataAlignment) -> ([InlineNode]) -> BlockNode

private let centerAlignmentData = curry({ (_,f: TableDataNodeGen) in f(.center) }) <^> (space.many *> colon *>  hyphen.many1 *> colon *> space.many *> tableSep.lookAhead)

private let leftAlignmentData = curry({ (_,f: TableDataNodeGen) in f(.left) }) <^> (space.many *> colon.optional *> hyphen.many1 *> space.many *> tableSep.lookAhead)

private let rightAlignmentData = curry({ (_,f: TableDataNodeGen) in f(.right) }) <^> (space.many *> hyphen.many1 *> colon *> space.many *> tableSep.lookAhead)


private func specificAmountTableRow(_ n: Int) -> MDParser<[[InlineNode]]> {
    
    return tableSep *> (tableData <* tableSep).repeat(n) <* space.many
}


private func specificAmountDelimiterRow(_ n: Int) -> Parser<Substring, [(TableDataNodeGen) -> ([InlineNode]) -> BlockNode]> {
    
    let delimiterItem = leftAlignmentData <|> centerAlignmentData <|> rightAlignmentData
    return tableSep *> (delimiterItem <* tableSep).repeat(n) <* space.many  // <* lineBreak
}
